source: trunk/MagicSoft/Mars/datacenter/scripts/runganymed@ 7076

Last change on this file since 7076 was 7067, checked in by Daniela Dorner, 20 years ago
*** empty log message ***
  • Property svn:executable set to *
File size: 7.1 KB
Line 
1#!/bin/sh
2#
3# ========================================================================
4#
5# *
6# * This file is part of MARS, the MAGIC Analysis and Reconstruction
7# * Software. It is distributed to you in the hope that it can be a useful
8# * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
9# * It is distributed WITHOUT ANY WARRANTY.
10# *
11# * Permission to use, copy, modify and distribute this software and its
12# * documentation for any purpose is hereby granted without fee,
13# * provided that the above copyright notice appear in all copies and
14# * that both that copyright notice and this permission notice appear
15# * in supporting documentation. It is provided "as is" without express
16# * or implied warranty.
17# *
18#
19#
20# Author(s): Daniela Dorner 08/2004 <mailto:dorner@astro.uni-wuerzburg.de>
21#
22# Copyright: MAGIC Software Development, 2000-2004
23#
24#
25# ========================================================================
26#
27#
28
29source /home/operator/Mars/datacenter/scripts/sourcefile
30
31set -C
32
33table=DataSetProcessStatus
34column=fGanymed
35date=NULL
36datetime=`date +%F-%H-%M-%S`
37year=`date +%Y`
38pno=24 # number of processes, i.e. number of todo-files
39
40todofile=/magic/datacenter/lists/ToDo-$table-$column
41getstatuslogpath=$logpath/getstatus/ganymed/$year
42getstatuslog=$getstatuslogpath/getstatus-ganymed-$datetime.log
43
44scriptlogpath=$logpath/run/ganymed/`date +%Y/%m/%d`
45if [ ! -d $scriptlogpath ]
46then
47 mkdir -pv $scriptlogpath
48 if [ ! -d $scriptlogpath ]
49 then
50 echo "could not make scriptlogpath "$scriptlogpath
51 exit
52 fi
53fi
54
55scriptlog=$scriptlogpath/runganymed-$datetime.log
56
57date >> $scriptlog 2>&1
58
59
60if [ ! -d $getstatuslogpath ]
61then
62 mkdir -pv $getstatuslogpath >> $scriptlog 2>&1
63 if [ ! -d $getstatuslogpath ]
64 then
65 echo "could not make getstatuslogpath "$getstatuslogpath >> $scriptlog 2>&1
66 date >> $scriptlog 2>&1
67 exit
68 fi
69fi
70
71#cd $mars
72
73macrospath=/home/operator/Mars.cvs/datacenter/macros
74cd /home/operator/Mars.cvs
75
76date > $lockpath/lock-getting-ganymed-list.txt >> $scriptlog 2>&1
77checklock0=$?
78case $checklock0 in
79 0) echo "checklock0=$checklock0 -> continue " >> $scriptlog 2>&1;;
80 1) echo "checklock0=$checklock0 -> file exists " >> $scriptlog 2>&1
81 echo "-> getting list for ganymed is running -> exit" >> $scriptlog 2>&1
82 date >> $scriptlog 2>&1
83 exit;;
84 *) echo "checklock0=$checklock0 -> something went completely wrong" >> $scriptlog 2>&1;;
85esac
86
87echo "checking if other todo-files are there" >> $scriptlog 2>&1
88if ls $todofile-[1-9]*.txt >> $scriptlog 2>&1
89then
90 echo "other file(s) on disk " >> $scriptlog 2>&1
91 echo " -> choose one file and run ganymed" >> $scriptlog 2>&1
92else
93 echo "getting list..." >> $scriptlog 2>&1
94 check0=`root -q -b $macrospath/getdolist.C+\("\"$table\""\,"\"$column\""\,"\"$date\""\) | tee $getstatuslog | grep int | sed -e 's/(int)//'`
95
96 case $check0 in
97 1) echo "check0=$check0 -> everthing ok -> run ganymed" >> $scriptlog 2>&1;;
98 *) echo "check0=$check0 -> ERROR -> step has to be repeated" >> $scriptlog 2>&1;;
99 esac
100 echo "cutting to-do-file" >> $scriptlog 2>&1
101 echo "getting no of lines" >> $scriptlog 2>&1
102 lines=`cat $todofile.txt | wc -l`
103 echo "number of lines: "$lines >> $scriptlog 2>&1
104 while (( "$lines" < "$pno" ))
105 do
106 echo "# of lines ($lines) < # of processes ($pno) "
107 pno=`expr $pno / 2`
108 done
109 echo "pno: "$pno
110 nofiles=`expr $lines / \( $pno - 1 \)`
111 echo "number of files: "$nofiles >> $scriptlog 2>&1
112 echo "deviding todo-file" >> $scriptlog 2>&1
113 for (( j=1 ; j <= $pno ; j++ ))
114 do
115 begin=$(echo "1 + ( ($j - 1) * $nofiles)" | bc -l)
116 end=$(echo "$begin + $nofiles - 1" | bc -l)
117 echo "begin: "$begin >> $scriptlog 2>&1
118 echo "end: "$end >> $scriptlog 2>&1
119 file=${todofile}-${j}.txt
120 echo "file: "$file >> $scriptlog 2>&1
121 sed -ne ''"$begin"','"$end"'w '"$file"'' $todofile.txt
122 done
123
124 rm -v $todofile.txt >> $scriptlog 2>&1
125fi
126
127rm -v $lockpath/lock-getting-ganymed-list.txt >> $scriptlog 2>&1
128
129nr=bla
130echo "finding the right todo-file" >> $scriptlog 2>&1
131for (( i = 1; i <= $pno ; i++ ))
132do
133 if ! ls $todofile-$i.txt >> $scriptlog 2>&1
134 then
135 echo "file is not on disk -> continue" >> $scriptlog 2>&1
136 continue
137 fi
138 date > $lockpath/lock-$table-$column-$i.txt >> $scriptlog 2>&1
139 checklock=$?
140 case $checklock in
141 0) echo "checklock=$checklock -> setting number" >> $scriptlog 2>&1
142 nr=${i}
143 break;;
144 1) echo "checklock=$checklock -> file exists -> continue" >> $scriptlog 2>&1;;
145 *) echo "checklock=$checklock -> something went completely wrong" >> $scriptlog 2>&1;;
146 esac
147done
148
149case $nr in
150 bla) echo "everything is beeing processed -> exit" >> $scriptlog 2>&1
151 date >> $scriptlog 2>&1
152 exit;;
153 12345678) echo "process nr: "$nr >> $scriptlog 2>&1;;
154esac
155
156
157datasets=(`cat $todofile-$nr.txt`)
158
159if [ "$datasets" = "" ]
160then
161 echo "nothing to do -> exit" >> $scriptlog 2>&1
162 rm -v $todofile-$nr.txt >> $scriptlog 2>&1
163 rm -v $lockpath/lock-$table-$column-$nr.txt >> $scriptlog 2>&1
164 date >> $scriptlog 2>&1
165 exit
166fi
167
168echo "datasets: "${datasets[@]} >> $scriptlog 2>&1
169
170for dataset in ${datasets[@]}
171do
172 no=`printf %08d $dataset | cut -c 0-5`
173 no2=`printf %08d $dataset`
174 outpath="/magic/data/ganymed/$no/$no2"
175 echo "outpath: "$outpath >> $scriptlog 2>&1
176 if [ ! -d $outpath ]
177 then
178 mkdir -pv $outpath >> $scriptlog 2>&1
179 if [ ! -d $outpath ]
180 then
181 echo "could not make outpath $outpath -> continue " >> $scriptlog 2>&1
182 continue
183 fi
184 fi
185 datasetfile="/magic/datasets/$no/dataset$no2.txt"
186 echo "datasetfile: "$datasetfile >> $scriptlog 2>&1
187
188 echo "run ganymed..." >> $scriptlog 2>&1
189 ./ganymed -b -q -f --log=$outpath/ganymed$no2.log --out=$outpath $datasetfile 2>> $scriptlog> /dev/null
190 check1=$?
191
192 case $check1 in
193 0) echo "check1=$check1 -> everthing ok " >> $scriptlog 2>&1
194 echo "-> inserting the status for ganymed for dataset $dataset into the db" >> $scriptlog 2>&1
195 setstatuslogpath=$logpath/setstatus/ganymed/$no
196 if [ ! -d $setstatuslogpath ]
197 then
198 mkdir -pv $setstatuslogpath >> $scriptlog 2>&1
199 if [ ! -d $setstatuslogpath ]
200 then
201 echo "could not make setstatuslogpath "$setstatuslogpath >> $scriptlog 2>&1
202 continue
203 fi
204 fi
205 setstatuslog=$setstatuslogpath/setstatus-ganymed-$no2.log
206 check4=`root -q -b $macrospath/setstatus.C+\("\"$dataset\""\,"\"$table\""\,"\"$column\""\,"\"Now()\""\) | tee $setstatuslog | grep int | sed -e 's/(int)//'`
207 case $check4 in
208 1) echo "check4=$check4 -> everthing ok, status has been set" >> $scriptlog 2>&1;;
209 *) echo "check4=$check4 -> ERROR -> step could not be set" >> $scriptlog 2>&1;;
210 esac
211 ;;
212 *) echo "check1=$check1 -> ERROR -> step has to be repeated" >> $scriptlog 2>&1;;
213 esac
214done
215
216rm -v $todofile-$nr.txt >> $scriptlog 2>&1
217rm -v $lockpath/lock-$table-$column-$nr.txt >> $scriptlog 2>&1
218
219set +C
220
221date >> $scriptlog 2>&1
222
Note: See TracBrowser for help on using the repository browser.